SystemOrganization addCategory: #HW5!

Object subclass: #WordStream
	instanceVariableNames: 'inputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW5'!

!WordStream commentStamp: '<historical>' prior: 0!
A WordStream converts a file into a stream of words.

Instance Variables
	inputStream:		<Object>

inputStream
	- xxxxx
!

!WordStream class methodsFor: 'instance creation' stamp: 'IsraSunhachawi 6/18/2013 22:19'!
on: aStream

	^self basicNew on: aStream

! !

!WordStream methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/18/2013 23:22'!
atEnd

^inputStream atEnd! !

!WordStream methodsFor: 'instance creation' stamp: 'IsraSunhachawi 6/18/2013 23:41'!
next

|  outputStream |

outputStream := String new writeStream.

inputStream do: [:eachChar | (eachChar isLetter) not
		ifTrue: [
			((outputStream size) > 0) ifTrue: [^outputStream]]
		ifFalse: [outputStream nextPut: eachChar.
			Transcript show: eachChar.]
		].
	
^outputStream contents

! !

!WordStream methodsFor: 'instance creation' stamp: 'IsraSunhachawi 6/18/2013 23:48'!
on: aStream 

| result |
result := OrderedCollection new.

inputStream := aStream.

[self atEnd] whileFalse: 
[result add: (self next) contents].

^result! !

TestCase subclass: #HW5Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW5'!

!HW5Test methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/19/2013 00:01'!
setUp 

|stream|
stream := FileStream forceNewFileNamed: 'test1.txt'. 
stream
	nextPutAll: 'does it have to make sense'.
stream close.! !

!HW5Test methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/19/2013 00:07'!
testPunctuationOffset

|a b c d|
a := WordStream on: 'hello world' readStream.
self assert: (a size) = 2.

b := WordStream on: ' hello world' readStream.
self assert: (b size) = 2.

c := WordStream on: 'hello world ' readStream.
self assert: (c size) = 2.

d := WordStream on: 'hello  world' readStream.
self assert: (d size) = 2.! !

!HW5Test methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/19/2013 00:01'!
testWordCount

|a|
a := WordStream on: (FileStream readOnlyFileNamed: 'test1.txt').

self assert: (a size) = 6! !
